module 'data.ref.backtrackable' {
   new(Initial, Ref) :-
      'kernel':ref_backtrackable_new(Initial, X),
      module Ref [Ref, X] {
         get(V) :-
            'kernel':ref_backtrackable_get(X, V).

         set(V) :-
            'kernel':ref_backtrackable_set(X, V).

         portray(S) :-
            S:format('data.ref.backtrackable:(~p)', [Ref:get]).
      }.

   new = 'data.ref.backtrackable':new(_).
}
